
#pragma used+
sfrb ADCSRB=0x03;
sfrb ADCL=0x04;
sfrb ADCH=0x05;
sfrw ADCW=0x04; 
sfrb ADCSRA=0x06;
sfrb ADMUX=0x07;
sfrb ACSR=0x08;
sfrb DIDR0=0x14;
sfrb PCMSK=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb WDTCR=0x21;
sfrb CLKPR=0x26;
sfrb GTCCR=0x28;
sfrb OCR0B=0x29;
sfrb DWDR=0x2e;
sfrb TCCR0A=0x2f;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR0=0x38;
sfrb TIMSK0=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

const unsigned char phrase[] = "CQ CQ DE BEACON 1/2W FROM SPB RU 60N 30E SEND REPORTS TO BEACONSPB  GMAIL COM.";

const unsigned char symbols[] = { 
1,0,0,1,0, 1,1,1,1,1, 0,1,1,1,1, 0,0,1,1,1, 0,0,0,1,1, 0,0,0,0,1, 0,0,0,0,0, 1,0,0,0,0, 1,1,0,0,0, 1,1,1,0,0, 1,1,1,1,0,    
2,2,2,5,5       , 2,2,2,5,5       , 2,2,2,5,5       , 2,2,2,5,5       , 2,2,2,5,5       , 2,2,2,5,5       , 2,2,2,5,5       ,                     
0,1,5,5,5, 1,0,0,0,5, 1,0,1,0,5, 1,0,0,5,5, 0,5,5,5,5, 0,0,1,0,5, 1,1,0,5,5, 0,0,0,0,5, 0,0,5,5,5, 0,1,1,1,5, 1,0,1,5,5, 0,1,0,0,5, 1,1,5,5,5, 1,0,5,5,5, 1,1,1,5,5, 0,1,1,0,5, 1,1,0,1,5, 0,1,0,5,5, 0,0,0,5,5, 1,5,5,5,5, 0,0,1,5,5, 0,0,0,1,5, 0,1,1,5,5, 1,0,0,1,5, 1,0,1,1,5, 1,1,0,0,5 
};

void morze_out(flash unsigned char *pData)
{                       
unsigned char p, p1;
for(p=0; p<128; p++)
{                       
unsigned char symb = pData[p];
if (symb == '.') break;
if (symb == '*') 
{ 
PORTB.0   = 1; 
TCCR0A=0x23;
delay_ms(1000); 
PORTB.0   = 0; 
TCCR0A=0x03;
delay_ms(80); 
continue; 
}                

if (symb == ' ') symb = '='; 
if (symb >= '/' && symb <= 'Z')
{                
unsigned int symb_code  = symb - '/';
unsigned int symb_index = 5*symb_code;    
if (symb_index >= sizeof(symbols)) continue;  

for(p1=0; p1<5; p1++)
{
if (symbols[symb_index + p1] == 0) 
{                     
PORTB.0   = 1; 
TCCR0A=0x23;
delay_ms(80);
PORTB.0   = 0;   
TCCR0A=0x03;
delay_ms(80);
} else
if (symbols[symb_index + p1] == 1) 
{                     
PORTB.0   = 1;  
TCCR0A=0x23;
delay_ms(3*80);
PORTB.0   = 0;   
TCCR0A=0x03;
delay_ms(80);
} else
if (symbols[symb_index + p1] == 2) 
{                     
delay_ms(80);
} 
}                                                          

delay_ms(3*80  );
} 
}
}

void main(void)
{

PORTB=0x00;
DDRB=0x3F;

TCCR0A=0x23;
TCCR0B=0x03;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x80;

GIMSK=0x00;
MCUCR=0x00;

TIMSK0=0x00;

ACSR=0x80;
ADCSRB=0x00;  

TCCR0A=0x03;

while (1)
{                         
unsigned char p;
for(p=0; p<3; p++)
{
morze_out(phrase);

PORTB.2    = 1;
delay_ms(1500);
PORTB.2    = 0;
}

delay_ms(12000);             

};
}
